﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
import mx.controls.cells.CheckCellRenderer
import mx.controls.CheckBox;
import org.silex.core.Utils;
import mx.controls.NumericStepper;
import mx.managers.DepthManager;

class org.silex.toolbox.LibraryCellRenderer extends CheckCellRenderer{
	
	var listOwner : MovieClip; // the reference we receive to the list
	var getCellIndex : Function; // the function we receive from the list
	var	getDataLabel : Function; // the function we receive from the list
	
	// UI
	
	//
	var label:String="";

	// constants :
	var preferedHeight:Number=44;
	
	
/*	function LibraryCellRenderer()
	{
		trace(" ---- ");
		var _str="";
		for(var idx in this)
		{
			_str+=idx+" = "+this[idx]+"<br>";²
		}
	}*/

	function createChildren(Void) : Void
	{
		this.onPress=Utils.createDelegate(this,onPressCallback);
		this.onRelease=Utils.createDelegate(this,onReleaseCallback);
		this.onReleaseOutside=Utils.createDelegate(this,onReleaseOutsideCallback);
		this.useHandCursor=false;
		size();
	}
	var libraryDragItem_mc:MovieClip;
	function onPressCallback () {
		libraryDragItem_mc=listOwner._parent.createChildAtDepth("LibraryDragItem",DepthManager.kTop);
		//libraryDragItem_mc=listOwner._parent.attachMovie("LibraryDragItem","libraryDragItem_mc",listOwner._parent.getNextHighestDepth());
		trace("onPressCallback "+libraryDragItem_mc);
		libraryDragItem_mc.startDrag(true);
	}
	function onReleaseCallback() {
		trace("onReleaseCallback");
		libraryDragItem_mc.stopDrag();
		libraryDragItem_mc.removeMovieClip();
		listOwner.selectedIndex=getCellIndex().itemIndex;
	}
	function onReleaseOutsideCallback() {
		trace("onReleaseOutsideCallback");
		trace(libraryDragItem_mc._droptarget);
		libraryDragItem_mc.stopDrag();
		libraryDragItem_mc.removeMovieClip();
		//libraryDragItem_mc=undefined;
		listOwner.selectedIndex=getCellIndex().itemIndex;
		listOwner._parent._parent._parent.layers_tool.main.addFromLibrary();
	}

	// note that setSize is implemented by UIComponent and calls size(), after setting
	// __width and __height

	function setValue(str:String, item:Object, sel:Boolean) : Void
	{
/*	trace("setValue "+str);
		for (var idx in item)
		{
			trace(idx+"->"+item[idx]);
		}
/**/
		//check._visible = (item!=undefined);
		//check.selected = item[getDataLabel()];
		if (item==undefined)
		{
			_parent._visible = false;
			return;
		}
		
		_parent._visible=true;
		label=str;

//		if (item[listOwner._parent.itemTypeField]=="folder")
	}

	function getPreferredHeight(Void) : Number
	{
		return preferedHeight;
	}

	function getPreferredWidth(Void) : Number
	{
		return listOwner._width;
	}
	function size(Void) : Void
	{
		//_width=__width;
		//_height=__height;
	}
}
