﻿class org.silex.ui.menu.ContextMenuItemWithKeyboardShortcut extends ContextMenuItem{
	//const
	static var F5_ASCII:Number = 116;
	var _keyCodeLc:Number = -1;
	var _keyCodeUc:Number = -1;
	var _withCtrlKey:Boolean = false;
	//key can be a number (ascii code) :  This is for example for F5, not a key, but ascii 116
	//or a character. "L".
	//if you need both cases, don't use the keycode, use the string
    public function ContextMenuItemWithKeyboardShortcut(caption:String, callbackFunction:Function, key:Object, withCtrlKey:Boolean)
    {
	    super(caption, callbackFunction, false, enabled, true);
		_withCtrlKey = withCtrlKey;
		if(typeof key == "string"){
			_keyCodeLc = key.toLowerCase().charCodeAt(0);
			_keyCodeUc = key.toUpperCase().charCodeAt(0);
		}else{
			_keyCodeLc = Number(key);
		}
        Key.addListener(this);
    }

    public function onKeyDown():Void
    {
		//trace(caption + " ContextMenuItemWithKeyboardShortcut caught keydown. pressed key code is " + Key.getCode());
		//trace("_keyCodeLc : " + _keyCodeLc + ", _keyCodeUc :" + _keyCodeUc); 
		//trace("_withCtrlKey : " + _withCtrlKey + ", is down : " + Key.isDown(Key.CONTROL));
		if(_withCtrlKey && !Key.isDown(Key.CONTROL)){
			return;
		}
		
		if(!_withCtrlKey && Key.isDown(Key.CONTROL)){
			return;
		}
		
		if(!enabled){
			return;
		}
		
        if((Key.getCode() == _keyCodeLc) || (Key.getCode() == _keyCodeUc))
        {
			trace(caption + "menu item called");
            onSelect();
        }
    }
	
}