﻿import mx.utils.Delegate;
import org.oof.OofBase; 
import org.oof.lists.cellRenderers.RichTextCellRenderer; 

/** this is like a rich text cell renderer, except that the alpha of the background is set to 50% every other cell
 * giving a 'stripe' effect
 * @author Ariel Sommeria-klein
 * */
class org.oof.lists.cellRenderers.StripeCellRenderer extends RichTextCellRenderer {
	
	function setValue(str:String, item:Object, sel:Boolean) : Void {
		super.setValue(str, item, sel);		
		var cellIndex = getCellIndex();
		var pos = cellIndex.itemIndex * listOwner.itemsPerRow + cellIndex.columnIndex;
		var doShade:Boolean = (pos % 2) > 0;
		if (doShade) {
			bg_btn._alpha = 50;
		}
	}
	
}