﻿/*
	this file is part of OOF
	OOF : Open Source Open Minded Flash Components

	OOF is (c) 2008 Alexandre Hoyau and Ariel Sommeria-Klein. It is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/

/** a utility class for time formatting
 * @author Ariel Sommeria-klein
 * */

class org.oof.util.TimeFormat {
    
    private function TimeFormat() { } 
    
    public static function format(number:Number):String {
        
        var seconds:Number = Math.floor(number%60);
        var minutes:Number = Math.floor(number/60);
        
        if (!isNaN(number)) {
            
            if (seconds<10) return minutes + ":0" + seconds;
            else          return minutes + ":"  + seconds;
        
        } else {
            return "0:00";
        }
    }
}