﻿/*
	this file is part of SILEX
	SILEX : RIA developement tool - see http://silex-ria.org/

	SILEX is (c) 2004-2007 Alexandre Hoyau and is released under the GPL License:

	This program is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License (GPL)
	as published by the Free Software Foundation; either version 2
	of the License, or (at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.
	
	To read the license please visit http://www.gnu.org/copyleft/gpl.html
*/
/**
 * The interface that must be implemented by all toolbox of an
 * Toolbox object.
 */
interface org.silex.toolbox.ToolboxInterface {
	
	// Refresh the container
	public function refresh():Void;
	
	/* This function is called by a tool box which will show the selection's details
	 * For example the player tool box will return an array containing all the selected players
	 * so that the properties tool box can display the corresponding editable properties.
	 */
	public function getSelectedContent():Array;
}